﻿using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Dynamic2D;

using Game = Dynamic2D.Game;

namespace Stardrive
{
    public class BulletBase : Dynamic2D.GameObjectBase
    {
        public float damage = 1;
    }

    public class Bullet : Dynamic2D.Bullet
    {
        public Vector2 origin;
        public float range;
        public float damage;
        public StardriveGame.Faction faction;

        public Bullet(BulletBase _BaseBullet)
            : base(_BaseBullet)
        {
            damage = _BaseBullet.damage;
        }

        public override void PostAddToGame()
        {
            base.PostAddToGame();

            origin = position;
        }

        public override void Update(GameTime gameTime)
        {
            base.Update(gameTime);

            if (Vector2.DistanceSquared(position, origin) >= range * range)
            {
                RemoveFromGame();
            }
        }

        public override bool CanCollideWith(GameObject other)
        {
            if (other is Ship)
            {
                if (((Ship)other).faction != faction)
                {
                    return true;
                }
            }
            return false;
        }
        
        public override void NotifyCollision(GameObject other)
        {
            if (other is Ship)
            {
                ((Ship)other).TakeDamage(damage);
                RemoveFromGame();
            }
        }
    }
}
