﻿using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Dynamic2D;

using Game = Dynamic2D.Game;

namespace Stardrive
{
    public class ChatBoxBase : GameObjectBase
    {
        public SpriteFont font;

        public Box9 border;

        public float charDelay = 0.05f;
    }

    public class ChatBox : GameObject
    {
        public Vector2 size;

        public string text = "";
        public int start = 0;
        int cursor = 0;
        float cursorTimer = 0.0f;

        public ChatBox(ChatBoxBase BaseChatBox)
            : base(BaseChatBox)
        {
        }

        public override void PostAddToGame()
        {
            base.PostAddToGame();

            ChatBoxBase BaseChatBox = (ChatBoxBase)BaseObject;

            cursor = start;
            cursorTimer = BaseChatBox.charDelay;
        }

        public override void Update(GameTime gameTime)
        {
 	        base.Update(gameTime);

            bool fast = false;

            if (game.keyboardState.IsKeyDown(Keys.Enter)
                || game.keyboardState.IsKeyDown(Keys.Space)
                || game.gamePadState.IsButtonDown(Buttons.A))
            {
                fast = true;
            }

            ChatBoxBase BaseChatBox = (ChatBoxBase)BaseObject;
            if (cursor < text.Length)
            {
                if (fast)
                {
                    cursorTimer -= (float)gameTime.ElapsedGameTime.TotalSeconds * 4;
                }
                else
                {
                    cursorTimer -= (float)gameTime.ElapsedGameTime.TotalSeconds;
                }

                if (cursorTimer <= 0)
                {
                    cursor++;
                    cursorTimer += BaseChatBox.charDelay;
                }
            }
        }

        public override void Draw(GameTime gameTime)
        {
            ChatBoxBase BaseChatBox = (ChatBoxBase)BaseObject;

            BaseChatBox.border.Draw(game, position, size, layerDepth);
            game.spriteBatch.DrawString(BaseChatBox.font, text.Substring(0, cursor), position + new Vector2(BaseChatBox.border.x1, BaseChatBox.border.y1), Color.White);
        }

        public bool HasFinished()
        {
            return cursor >= text.Length;
        }
    }
}
