﻿using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Dynamic2D;

using Game = Dynamic2D.Game;

namespace Stardrive
{
    public class LogoBoxBase : GameObjectBase
    {
        public SpriteFont font;

        public Box9 border;
    }

    public class LogoBox : GameObject
    {
        public Vector2 size;

        public string text = "";

        public LogoBox(LogoBoxBase BaseLogoBox)
            : base(BaseLogoBox)
        {
        }

        public override void PostAddToGame()
        {
            base.PostAddToGame();

            LogoBoxBase BaseLogoBox = (LogoBoxBase)BaseObject;
            size = BaseLogoBox.font.MeasureString(text) + new Vector2(BaseLogoBox.border.x1 + BaseLogoBox.border.x3 - BaseLogoBox.border.x2, BaseLogoBox.border.y1 + BaseLogoBox.border.y3 - BaseLogoBox.border.y2);
        }

        public override void Update(GameTime gameTime)
        {
 	        base.Update(gameTime);
        }

        public override void Draw(GameTime gameTime)
        {
            LogoBoxBase BaseLogoBox = (LogoBoxBase)BaseObject;

            BaseLogoBox.border.Draw(game, position - size / 2, size, layerDepth);
            game.spriteBatch.DrawString(BaseLogoBox.font, text, position - size / 2 + new Vector2(BaseLogoBox.border.x1, BaseLogoBox.border.y1), Color.White);
        }
    }
}
