﻿using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Dynamic2D;

using Game = Dynamic2D.Game;

namespace Stardrive
{
    public class MenuBase : GameObjectBase
    {
        public SpriteFont font;

        public string[] menuItems;

        public Sprite MenuSelector;
        public string MenuSelectorString;
        public float MenuSelectorOffset;
    }

    public class Menu : GameObject
    {
        int Selection = 0;

        public Menu(MenuBase BaseMenu)
            : base(BaseMenu)
        {
        }

        public override void PostAddToGame()
        {
            Selection = 0;

            base.PostAddToGame();
        }

        public override void Update(GameTime gameTime)
        {
 	        base.Update(gameTime);

            MenuBase BaseMenu = (MenuBase)BaseObject;

            if (Selection > 0)
            {
                if (game.keyboardState.IsKeyDown(Keys.Up) && !game.prevKeyboardState.IsKeyDown(Keys.Up)
                    || game.gamePadState.IsButtonDown(Buttons.DPadUp) && !game.prevGamePadState.IsButtonDown(Buttons.DPadUp)
                    || game.gamePadState.ThumbSticks.Left.Y > 0 && game.prevGamePadState.ThumbSticks.Left.Y <= 0)
                {
                    Selection--;
                }
            }
            if (Selection < BaseMenu.menuItems.Length - 1)
            {
                if (game.keyboardState.IsKeyDown(Keys.Down) && !game.prevKeyboardState.IsKeyDown(Keys.Down)
                    || game.gamePadState.IsButtonDown(Buttons.DPadDown) && !game.prevGamePadState.IsButtonDown(Buttons.DPadDown)
                    || game.gamePadState.ThumbSticks.Left.Y < 0 && game.prevGamePadState.ThumbSticks.Left.Y >= 0)
                {
                    Selection++;
                }
            }

            if (game.keyboardState.IsKeyDown(Keys.Enter) && !game.prevKeyboardState.IsKeyDown(Keys.Enter)
                || game.keyboardState.IsKeyDown(Keys.Space) && !game.prevKeyboardState.IsKeyDown(Keys.Space)
                || game.gamePadState.IsButtonDown(Buttons.A) && !game.prevGamePadState.IsButtonDown(Buttons.A)
                || game.gamePadState.IsButtonDown(Buttons.Start) && !game.prevGamePadState.IsButtonDown(Buttons.Start))
            {
                ((StardriveGame)game).HandleMenuItem(BaseMenu.menuItems[Selection]);
            }
        }

        public override void Draw(GameTime gameTime)
        {
            MenuBase BaseMenu = (MenuBase)BaseObject;

            Vector2 MenuStep = new Vector2(0, 100);

            Vector2 MenuItemPosition = position;
            foreach (string menuItem in BaseMenu.menuItems)
            {
                game.spriteBatch.DrawString(BaseMenu.font, menuItem, MenuItemPosition, Color.White);
                MenuItemPosition += MenuStep;
            }

            Vector2 SelectorPosition = position + MenuStep * Selection;
            SelectorPosition.X += BaseMenu.MenuSelectorOffset;
            if (BaseMenu.MenuSelector.texture != null)
            {
                SelectorPosition.Y += BaseMenu.font.MeasureString(BaseMenu.menuItems[Selection]).Y / 2;
                game.DrawObjectScreenSpace(BaseMenu.MenuSelector, SelectorPosition, rotation, scale, layerDepth);
            }
            else
            {
                game.spriteBatch.DrawString(BaseMenu.font, BaseMenu.MenuSelectorString, SelectorPosition, Color.White);
            }
        }
    }
}
